// Licensed under the Apache License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License. You may obtain
// a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations
// under the License.

use lazy_static::lazy_static;
use std::sync::Mutex;

lazy_static! {
    pub static ref FALCON_CMAP: Mutex<Vec<(usize, usize)>> = Mutex::new(vec![
        (0, 1),
        (1, 0),
        (1, 2),
        (1, 4),
        (2, 1),
        (2, 3),
        (3, 2),
        (3, 5),
        (4, 1),
        (4, 7),
        (5, 3),
        (5, 8),
        (6, 7),
        (7, 4),
        (7, 6),
        (7, 10),
        (8, 5),
        (8, 9),
        (8, 11),
        (9, 8),
        (10, 7),
        (10, 12),
        (11, 8),
        (11, 14),
        (12, 10),
        (12, 13),
        (12, 15),
        (13, 12),
        (13, 14),
        (14, 11),
        (14, 13),
        (14, 16),
        (15, 12),
        (15, 18),
        (16, 14),
        (16, 19),
        (17, 18),
        (18, 15),
        (18, 17),
        (18, 21),
        (19, 16),
        (19, 20),
        (19, 22),
        (20, 19),
        (21, 18),
        (21, 23),
        (22, 19),
        (22, 25),
        (23, 21),
        (23, 24),
        (24, 23),
        (24, 25),
        (25, 22),
        (25, 24),
        (25, 26),
        (26, 25),
    ]);
    pub static ref EAGLE_CMAP: Mutex<Vec<(usize, usize)>> = Mutex::new(vec![
        (1, 0),
        (1, 2),
        (3, 2),
        (4, 3),
        (4, 15),
        (5, 4),
        (6, 5),
        (7, 6),
        (8, 7),
        (8, 9),
        (10, 9),
        (10, 11),
        (11, 12),
        (12, 13),
        (14, 0),
        (14, 18),
        (16, 8),
        (17, 12),
        (17, 30),
        (18, 19),
        (19, 20),
        (20, 33),
        (21, 20),
        (21, 22),
        (22, 15),
        (23, 22),
        (23, 24),
        (25, 24),
        (26, 16),
        (26, 25),
        (26, 27),
        (28, 27),
        (29, 28),
        (29, 30),
        (31, 30),
        (31, 32),
        (32, 36),
        (33, 39),
        (34, 24),
        (35, 28),
        (35, 47),
        (36, 51),
        (37, 38),
        (38, 39),
        (40, 39),
        (41, 40),
        (41, 53),
        (42, 41),
        (43, 34),
        (43, 42),
        (43, 44),
        (45, 44),
        (45, 46),
        (47, 46),
        (47, 48),
        (49, 48),
        (49, 50),
        (50, 51),
        (52, 37),
        (53, 60),
        (54, 45),
        (55, 49),
        (56, 52),
        (56, 57),
        (57, 58),
        (59, 58),
        (59, 60),
        (61, 60),
        (61, 62),
        (63, 62),
        (63, 64),
        (64, 54),
        (64, 65),
        (66, 65),
        (67, 66),
        (68, 55),
        (68, 67),
        (69, 68),
        (69, 70),
        (71, 58),
        (71, 77),
        (72, 62),
        (73, 66),
        (73, 85),
        (74, 70),
        (75, 76),
        (77, 76),
        (78, 77),
        (78, 79),
        (79, 91),
        (80, 79),
        (80, 81),
        (81, 72),
        (81, 82),
        (82, 83),
        (84, 83),
        (85, 84),
        (86, 85),
        (86, 87),
        (87, 88),
        (89, 74),
        (89, 88),
        (90, 75),
        (90, 94),
        (92, 83),
        (92, 102),
        (93, 87),
        (93, 106),
        (95, 94),
        (95, 96),
        (97, 96),
        (97, 98),
        (98, 91),
        (99, 98),
        (99, 100),
        (101, 100),
        (101, 102),
        (102, 103),
        (104, 103),
        (105, 104),
        (106, 105),
        (107, 106),
        (107, 108),
        (109, 96),
        (110, 100),
        (110, 118),
        (111, 104),
        (112, 108),
        (112, 126),
        (113, 114),
        (114, 109),
        (114, 115),
        (116, 115),
        (117, 116),
        (117, 118),
        (119, 118),
        (119, 120),
        (120, 121),
        (121, 122),
        (122, 111),
        (123, 122),
        (124, 123),
        (125, 124),
        (126, 125),
    ]);
}
